"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from .testcaseread import TestCaseRead, TestCaseReadTypedDict
from datetime import datetime
from flowai_sdk.types import (
    BaseModel,
    Nullable,
    OptionalNullable,
    UNSET,
    UNSET_SENTINEL,
)
from pydantic import model_serializer
from typing import List, Optional
from typing_extensions import NotRequired, TypedDict


class BatchReadTypedDict(TypedDict):
    r"""Schema for reading/returning batch data"""

    project_id: str
    pipeline_run_id: str
    id: str
    created_at: datetime
    updated_at: datetime
    total_test_cases: int
    completed_test_cases: int
    name: NotRequired[Nullable[str]]
    description: NotRequired[Nullable[str]]
    error: NotRequired[Nullable[str]]
    test_cases: NotRequired[List[TestCaseReadTypedDict]]


class BatchRead(BaseModel):
    r"""Schema for reading/returning batch data"""

    project_id: str

    pipeline_run_id: str

    id: str

    created_at: datetime

    updated_at: datetime

    total_test_cases: int

    completed_test_cases: int

    name: OptionalNullable[str] = UNSET

    description: OptionalNullable[str] = UNSET

    error: OptionalNullable[str] = UNSET

    test_cases: Optional[List[TestCaseRead]] = None

    @model_serializer(mode="wrap")
    def serialize_model(self, handler):
        optional_fields = ["name", "description", "error", "test_cases"]
        nullable_fields = ["name", "description", "error"]
        null_default_fields = []

        serialized = handler(self)

        m = {}

        for n, f in type(self).model_fields.items():
            k = f.alias or n
            val = serialized.get(k)
            serialized.pop(k, None)

            optional_nullable = k in optional_fields and k in nullable_fields
            is_set = (
                self.__pydantic_fields_set__.intersection({n})
                or k in null_default_fields
            )  # pylint: disable=no-member

            if val is not None and val != UNSET_SENTINEL:
                m[k] = val
            elif val != UNSET_SENTINEL and (
                not k in optional_fields or (optional_nullable and is_set)
            ):
                m[k] = val

        return m
